local AddonName, a = ...
local L = a.Localize
local s = SpellFlashAddon
local c = BittensSpellFlashLibrary2

a.Rotations = {}
c.RegisterForEvents(AddonName, a)
s.Spam[AddonName] = function()
    c.Flash(AddonName, a)
end

a.Focus = 0
local function calcFocus()
    local _, regen = GetPowerRegen()
    a.Focus = math.floor(s.Power("player") + regen * c.GetBusyTime(false, "Cobra Shot")) 
    if c.IsCasting("Cobra Shot") then
        if c.WearingSet(2, "T13") then
            a.Focus = a.Focus + 18
        else
            a.Focus = a.Focus + 9
        end
    end
end

----------------------------------------------------------------- Beast Mastery
a.Rotations.BeastMastery = {
    Spec = 1,
    OffSwitch = "bm_off",
    
    FlashInCombat = function()
        calcFocus()
        
        a.FlashAll(
            "Hunter's Mark", 
            "Bestial Wrath", 
            "Focus Fire",
            "Fervor")
        
        if a.Flash(
           "Kill Command",
           "Serpent Sting", 
           "Kill Shot") then
           
           return
        end
        
        if a.Focus > 70 or c.HasBuff("The Beast Within") then
            a.Flash("Arcane Shot")
        else
            a.Flash("Cobra Shot")
        end
    end,
    
    FlashAlways = function()
       a.FlashAll("Aspect of the Hawk", "Mend Pet", "Call Pet")
    end,
}

---------------------------------------------------------------------- Survival
local allowES = true
local lastES = 0

a.Rotations.Survival = {
    Spec = 3,
    OffSwitch = "survival_off",
    
    FlashInCombat = function()
        calcFocus()
        if GetTime() - lastES > 1 then
            allowES = true
        end
        
        a.FlashAll(
            "Hunter's Mark", 
            "Serpent Sting", 
            "Black Arrow", 
            "Kiroptyric Sigil")
        if allowES and a.Flash("Explosive Shot") then
            return
        end
        if a.Flash("Kill Shot") then
            return
        end
        
        if a.Focus > 60 then
            a.Flash("Arcane Shot")
        else
            a.Flash("Cobra Shot")
        end
    end,
    
    FlashAlways = function()
        a.FlashAll("Aspect of the Hawk", "Mend Pet", "Call Pet")
    end,
    
    CastSucceeded = function(spellID, target)
	    if spellID == c.GetID("Explosive Shot") then
		    if GetTime() - lastES < 2 then
		        allowES = false
		    end
		    lastES = GetTime()
	        c.Debug("Event", "Explosive Shot Fired", "Call Pet")
	    end
    end,
}
