local AddonName, a = ...
local L = a.Localize
local s = SpellFlashAddon
local c = BittensSpellFlashLibrary2

------------------------------------------------------------------------ Common
a.EquipmentSets = {}
a.EquipmentSets.T13 = {
    HeadSlot = { 78793, 77030, 78698 },
    ShoulderSlot = { 78832, 77032, 78737 },
    ChestSlot = { 78756, 77028, 78661 },
    HandsSlot = { 78769, 77029, 78674 },
    LegsSlot = { 78804, 77031, 78709 },
}

a.spells["Mend Pet"] = {
    ID = 136,
    FlashColor = "red",
    CheckFirst = function()
        return s.HealthPercent("pet") < 80
    end
}

a.spells["Hunter's Mark"] = {
    ID = 1130,
    Debuff = "Hunter's Mark",
    FlashColor = "yellow",
}

a.spells["Serpent Sting"] = {
    ID = 1978,
    MyDebuff = "Serpent Sting",
    EarlyRefresh = 2,
    Continue = 1,
    FlashColor = "yellow",
    NoPowerCheck = 1,
    CheckFirst = function()
        return a.Focus >= s.SpellCost(1978)
            and c.GetCooldown("Serpent Sting") == 0
    end
}

a.spells["Kill Shot"] = {
    ID = 53351,
}

a.spells["Arcane Shot"] = {
    ID = 3044,
}

a.spells["Cobra Shot"] = {
    ID = 77767,
}

a.spells["Aspect of the Hawk"] = {
    Type = "form",
    ID = 13165,
    NotWhileMoving = 1,
    CheckFirst = function()
        return not s.Form(20043) -- Aspect of the Wild
    end
}

a.spells["Explosive Trap"] = {
    ID = 13813,
}

a.spells["Kiroptyric Sigil"] = {
    Type = "item",
    ID = 77113,
    Continue = 1,
    FlashColor = "yellow",
    NoGCD = 1,
}

a.spells["Call Pet"] = {
    ID = 883,
    FlashID = { 883, 83242, 83243, 83244, 83245, 982 },
    FlashColor = "yellow",
    CheckFirst = function()
        return not IsMounted() and not UnitExists("pet")
    end
}

----------------------------------------------------------------- Beast Mastery
a.spells["The Beast Within"] = { ID = 34471 }
a.spells["Frenzy Effect"] = { ID = 19615 }

a.spells["Focus Fire"] = {
    ID = 82692,
    Buff = 82692,
    BuffUnit = "player",
    FlashColor = "yellow",
    CheckFirst = function()
        return s.BuffStack(c.GetID("Frenzy Effect"), "pet") == 5
            and not c.HasBuff("The Beast Within")
            and c.GetCooldown("Bestial Wrath") > 10
    end
}

a.spells["Kill Command"] = {
    ID = 34026,
    NoPowerCheck = 1,
    CheckFirst = function()
        return a.Focus >= s.SpellCost(34026)
            and c.GetCooldown("Kill Command") == 0
    end
}

a.spells["Bestial Wrath"] = {
    ID = 19574,
    NoGCD = 1,
    FlashColor = "yellow",
    CheckFirst = function()
        return s.Power("player") > 70
            and s.BuffStack(c.GetID("Frenzy Effect"), "pet") == 5
    end
}

a.spells["Fervor"] = {
    ID = 82726,
    FlashColor = "yellow",
    CheckFirst = function()
        return a.Focus < 50 and s.Power("pet") < 50
    end
}

---------------------------------------------------------------------- Survival
a.spells["Lock and Load"] = { ID = 56453 }

a.spells["Explosive Shot"] = {
    ID = 53301,
    Override = function()
        return (a.Focus >= s.SpellCost(53301) or c.HasBuff("Lock and Load"))
            and c.GetCooldown("Explosive Shot") == 0
    end
}

a.spells["Black Arrow"] = {
    ID = 3674,
    Continue = 1,
    FlashColor = "yellow",
    Override = function()
        return a.Focus >= s.SpellCost(3674)
            and c.GetCooldown("Black Arrow") == 0
    end
}
